import processing.core.*; import traer.physics.*; import processing.opengl.*; import traer.animation.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class dummy42_rotblau_web extends PApplet {



String[] beispielTitel =  {
    "Pf\u00fctzen, Pf\u00fctzen", "Ein Tag ohne Regen...", "Was habt ihr alle mit dem Wetter?", "Ich mag Herbstwetter", "Schneits bald wieder?", "Im September wars sch\u00f6ner", "Morgen wird es regnen","Regnet es morgen?","Absoluter Stuss!", "Die Regenmacher", "Der Sommer l\u00e4sst auf sich warten!", "Regenschirm einpacken!", "Meteorologengequassel..."};

String[] beispielTexte = {
   "Das ist ein furchtbar langer, schwer zu lesener und \u00fcberaus schlecht geschriebener Text. Dieser Text sollte von ihnen nicht gelesen werden.\n\nLesen Sie immer noch? Ok, dann gibts ne kleine Geschichte. Und wenn sie heute noch lesen, lesen sie immer noch. \nDas ist ein furchtbar langer, schwer zu lesener und \u00fcberaus schlecht geschriebener Text. \n\nDieser Text sollte von ihnen nicht gelesen werden. Lesen Sie immer noch? Ok, dann gibts ne kleine Geschichte. Und wenn sie heute noch lesen, lesen sie immer noch.",
  "Das ist ein furchtbar langer, schwer zu lesener und \u00fcberaus schlecht geschriebener Text. Dieser Text sollte von ihnen nicht gelesen werden.",
  "Das ist ein furchtbar langer, schwer zu lesener und \u00fcberaus schlecht geschriebener Text. Dieser Text sollte von ihnen nicht gelesen werden.\nLesen Sie immer noch? Ok, dann gibts ne kleine Geschichte. Und wenn sie heute noch lesen, lesen sie immer noch. \nDas ist ein furchtbar langer, schwer zu lesener und \u00fcberaus schlecht geschriebener Text. \n\nDieser Text sollte von ihnen nicht gelesen werden. Lesen Sie immer noch? Ok, dann gibts ne kleine Geschichte. Und wenn sie heute noch lesen, lesen sie immer noch. Das ist ein furchtbar langer, schwer zu lesener und \u00fcberaus schlecht geschriebener Text. Dieser Text sollte von ihnen nicht gelesen werden.\n\nLesen Sie immer noch? Ok, dann gibts ne kleine Geschichte. Und wenn sie heute noch lesen, lesen sie immer noch. \nDas ist ein furchtbar langer, schwer zu lesener und \u00fcberaus schlecht geschriebener Text. \n\nDieser Text sollte von ihnen nicht gelesen werden. Lesen Sie immer noch? Ok, dann gibts ne kleine Geschichte. Und wenn sie heute noch lesen, lesen sie immer noch.",
  "Das ist ein furchtbar langer, schwer zu lesener und \u00fcberaus schlecht geschriebener Text. Dieser Text sollte von ihnen nicht gelesen werden.\nLesen Sie immer noch? Ok, dann gibts ne kleine Geschichte. Und wenn sie heute noch lesen, lesen sie immer noch. \n\nDas ist ein furchtbar langer, schwer zu lesener und \u00fcberaus schlecht geschriebener Text."
  };
  
String[] beispielMetaDaten = {
  "Geschrieben am 24.06.2006\nvon Hans Brinker\nHansBrinker Hotel Blog",
  "Geschrieben am 29.06.2006\nvon J\u00f6rg Kachelmann\nDer Wetterblog",
  "Geschrieben am 05.07.2006\nvon Daniel Fischer\nDani's Olalaola-Blog",
  "Geschrieben am 04.07.2006\nvon Hazzle Schnibblr\nFreaks Online",
  "Geschrieben am 22.06.2006\nvon Heiri M\u00fcller\nTagesschau Revisited",
  "Geschrieben am 01.02.2006\nvon Bauer Horst\nDer R\u00fcebli-Talk",
  "Geschrieben am 12.07.2006\nvon Kai Wied\nKais Tuschlerei",
};

PFont fontInhaltOffen;
PFont fontInhaltZu;
PFont fontMeta;
PFont fontTitelOffen;
PFont fontTitelZu;

Smoother3D smoother;
ParticleSystem physics;                  // Partikel-System Objekt 
public Posts posts;

boolean klickAktiv;
float globaleHoehe = 30;
Vector3D globaleTranslation;
Vector3D alteMausPos;


// PROCESSING /////////////////////////////////////

public void setup()
{
  size( 900, 600, OPENGL );
  //smooth();
  frameRate( 24 );
  strokeWeight( 2 );
  rectMode(CORNER);  
//textMode(SCREEN);
  physics = new ParticleSystem( 0, .16f );
  smoother = new Smoother3D( 0.9f );
  smoother.setTarget(0,0,1); // da der z-wert als scale missbraucht wird, hier auf 1 setzen, damit am anfang nicht gerade skalliert wird
  Vector3D start = new Vector3D();


  globaleTranslation = new Vector3D();
  globaleTranslation.setXYZ(0,0,0);
  alteMausPos = new Vector3D();
  
  // Text f\u00fcr inhalt offen: Verdana Roman 10pt
  // Text f\u00fcr inhalt zu: Verdana Roman 8pt
  // Text f\u00fcr Meta: Verdana Italic 9pt
  // Text f\u00fcr Titel zu: Bauer Bodoni Roman 18pt
  // Text f\u00fcr titel offen: Bauer Bodoni Roman 25pt
  //fontInhaltOffen = loadFont("Verdana-20.vlw");
  fontInhaltOffen = loadFont("Verdana-14.vlw");
  fontInhaltZu = loadFont("Verdana-16.vlw");
  fontMeta = loadFont("Verdana-Italic-18.vlw");
  //fontTitelOffen = loadFont("BauerBodoni-Roman-36.vlw");
  fontTitelOffen = loadFont("BauerBodoni-Roman-20.vlw");
  //fontTitelZu = loadFont("BauerBodoni-Roman-50.vlw");
  fontTitelZu = loadFont("BauerBodoni-Roman-30.vlw");

  Vector3D ende = new Vector3D();
  start.setXYZ(200, 200,0);
  ende.setXYZ(start.x + 10 *25, 200, 0);
  posts = new Posts(start, ende, 10, true);
  postsErstellen();
}

public void draw()
{
  //println(klickAktiv);
   background( 0 );
   
   physics.tick( 1.4f ); 
   physics.tick( 1.4f );

   scale(smoother.z());
   pushMatrix();
   translate(smoother.x(), smoother.y());
   smoother.tick();
   


   fill(255,255,255);
   textFont(fontTitelOffen, 24);
   float textBreite = textWidth("Wetter:");
   float textHoehe = textAscent() + textDescent();
   float feldBreite = textBreite;
   text("Wetter:", 200-feldBreite-10,200-textHoehe/2, feldBreite, textHoehe);

  strokeWeight(3);
  stroke(255,0,0);

  posts.run();
  
  strokeWeight(0.5f);
  stroke(255,255,255, 255 );
  /*
  beginShape( LINES );
   for ( int i = 0; i < physics.numberOfSprings(); ++i )
   {
   Spring e = physics.getSpring( i );
   Particle a = e.getOneEnd();
   Particle b = e.getTheOtherEnd();
   vertex( a.position().x(), a.position().y() );
   vertex( b.position().x(), b.position().y() );
   
   //vertex( mouseX,mouseY);
   //vertex( b.position().x(), b.position().y() );
   //vertex( width,height);
   }
   endShape();
   */
   popMatrix();
}

public void mousePressed() {
  //if (mouseButton == LEFT) {
  if (keyPressed && key == ' ') {
     alteMausPos.setXY(mouseX, mouseY);
     println("mouse pressed"); 
  }  else if (keyPressed && key == 'z') {
     alteMausPos.setXY(mouseX, mouseY);
     println("mouse pressed zoom"); 
  } else {
   klickAktiv = true; 
  }
}




public void mouseDragged() {
    if ( keyPressed && key == ' '){
      
    Vector3D unterschied = new Vector3D();
    unterschied.setXY(mouseX, mouseY);
    unterschied.sub(alteMausPos);
    globaleTranslation.add(unterschied);
    alteMausPos.setXY(mouseX, mouseY);
    
    smoother.setTarget(globaleTranslation.x/smoother.z(), globaleTranslation.y/smoother.z(),smoother.z());
 
    } else if ( keyPressed && key == 'z'){
      float unterschied1 =  (alteMausPos.x-mouseX)/width;
      Vector3D unterschied = new Vector3D();
      Vector3D blabla = new Vector3D();
      blabla = alteMausPos.copy();
      unterschied = alteMausPos.copy();
      unterschied.mult(unterschied1);
      unterschied.sub(alteMausPos);
      
      //line(blabla.x, blabla.y, alteMausPos.x, alteMausPos.y);
      point(blabla.x, blabla.y);
      
      
      smoother.setTarget(smoother.x(), smoother.y(), smoother.z()+unterschied1); 
      //println(alteMausPos.x);
    }
}


public void keyPressed()
{
  if ( key == 'c' )
  {
    postsErstellen();
  }
  
  if ( key == ' ' )
  {
   if (mousePressed) {
           alteMausPos.setXY(mouseX, mouseY);
     //println("spezial"); 
   } 
  }
  
  if (key == 'z') {
    
     if (mousePressed) {
           //alteMausPos.setXY(mouseX, mouseY);
     //println("spezial"); 
   } 
  }


}

public void postsErstellen() {
    posts.kill();
    posts = null;
    Vector3D start = new Vector3D();
    Vector3D ende = new Vector3D();
    int randomAnzahl = PApplet.parseInt(random(1,20));
    start.setXYZ(200, 200,0);
    ende.setXYZ(start.x + randomAnzahl * 25, 200, 0);
    posts = new Posts(start, ende, randomAnzahl, true);
    smoother.setTarget(0,0,1);
}

public void updateCentroid()
{
  
  // die Test-Variablen auf die negative, resp. positive gr\u00f6sste m\u00f6gliche zahl setzen,
  // um nachher auf jede zahl vorbereitet zu sein
  float 
    xMax = Float.NEGATIVE_INFINITY, 
    xMin = Float.POSITIVE_INFINITY, 
    yMin = Float.POSITIVE_INFINITY, 
    yMax = Float.NEGATIVE_INFINITY;

// den h\u00f6chsten resp. tiefsten x-/y-werte herausfinden
  for ( int i = 0; i < physics.numberOfParticles(); ++i )
  {
    //max() gibt die gr\u00f6ssere der beiden zahlen zur\u00fcck, min() die kleinere
    Particle p = physics.getParticle( i );
    xMax = max( xMax, p.position().x() );
    xMin = min( xMin, p.position().x() );
    yMin = min( yMin, p.position().y() );
    yMax = max( yMax, p.position().y() );
  }
  float deltaX = xMax-xMin;
  float deltaY = yMax-yMin;
  if ( deltaY > deltaX )
    smoother.setTarget( xMin + 0.5f*deltaX, yMin +0.5f*deltaY, height/(deltaY+50) );
  else
    smoother.setTarget( xMin + 0.5f*deltaX, yMin +0.5f*deltaY, width/(deltaX+50) );
}

// Toxi's Gradiend Class
// Edited by Patrick Meister

class Gradient {
  
  private class GradPoint {
    int  pos;
    int  col;
    GradPoint(int p, int c) {
      pos=p;
      col=c;
    }
  }
  
  private GradPoint[] gradient;
  private int numColors;
  
  Gradient() {
    numColors=0;  
  }
  
  // add a new colour at specified position
  public void addColor(int p, int c) {
    if (numColors==0) {
      gradient=new GradPoint[1];
      gradient[numColors]=new GradPoint(p,c);
      numColors++;
    } else {
      GradPoint[] newGrad = new GradPoint[++numColors];
      System.arraycopy(gradient,0,newGrad,0,numColors-1);
      newGrad[numColors-1]=new GradPoint(p,c);
      gradient=newGrad;
    }
  }
  
  // generic linear interpolation
  public int mix(int a,int b, float f) { return (int)(a+(b-a)*f); }
  
  // blend 2 colours
  public int blend(int a, int b, float f) {
    return mix(a>>16,b>>16,f)<<16 | mix(a>>8&0xff,b>>8&0xff,f)<<8 | mix(a&0xff,b&0xff,f);
  }
  
  // calculate number of steps of gradient from specified position (only values >0)
  public int[] calcGradient(int pos, int steps) {
    int[] result=new int[steps];
    float imp;
    int first=numColors-1;
    int endPos=pos+steps;
    // find 1st colour needed, clamp start position to positive values only
    pos=(pos>-1) ? pos : 0;
    for(int i=0; i<numColors; i++) {
        if (gradient[i].pos>pos) { first=i-1; i=numColors; }
    }
    float currWidth=(first<numColors-1) ? 1.0f/(float)(gradient[first+1].pos-gradient[first].pos) : 0f;
    int i=0;
    while(pos<endPos) {
      imp=(pos-gradient[first].pos)*currWidth;
      // switch to next colour?
      if (imp>1) {
        first++;
        currWidth=(first<numColors-1) ? 1.0f/(float)(gradient[first+1].pos-gradient[first].pos) : 0f;
        imp=(pos-gradient[first].pos)*currWidth;
      }
      result[i++]=(first<numColors-1) ? blend(gradient[first].col,gradient[first+1].col,imp) : gradient[first].col;
      pos++;
    }
    return result;
  }
}

// Blogosphere Browser 0.1
// Patrick Meister, Juni 2006


class Post {

  Posts elternBaum;                       // Posts objekt f\u00fcr die eltern dieses Posts
  Posts kinderBaum;                       // Posts objekt f\u00fcr die kinder deises Posts
  Posts postsRef;                         // Referenz zum Posts-objekt (wird nicht hier erstellt!!!!!!!!!!)
  Particle linkesPartikel;                // Partikel, das den linken Rand bestimmt
  Particle rechtesPartikel;               // Partikel, das den rechten Rand bestimmt
  Spring meineSpring;                     // Spring-Objekt dieses Posts
  Attraction meineAttraction;             // Attraction-Objekt dieses Posts
  Vector3D startPunkt;                    // Startpunkt f\u00fcr dieses Post
  int anzahlAntworten;                    // Anzahl Antworten auf dieses Post (zuf\u00e4llig)
  int anzahlEltern;                       // Anzahl eltern dieses posts (zuf\u00e4llig)
  
  
  Gradient verlauf;
  int[] verlaufsFarben;

  float springLength = 3;
  float springStrength = .3f;
  float springDamping = .2f;
  float attractionStrength = 10;
  float breite;
  float hoehe;
  float alteHoehe;                   // alte hohe speichern, um ver\u00e4nderungen festzustellen und gezielt den verlauf neu zu berechnen
  float originalHoehe;               // speichert die geschlossene hohe dieses posts
  float ersteVergroesserung = 20;
  int altersNr;                      // speichert, der wievielte post dieser post in der reihe ist
  int anzahlPostsInBaum;             // speichert die anzahl br\u00fcder + 1 (anzahl posts in diesem (eltern-)baum
  
  Vector3D obenLinks;               // speichern die koordinaten der 4 ecken
  Vector3D obenRechts;
  Vector3D untenLinks;
  Vector3D untenRechts;
  
  float globalMouseX;
  float globalMouseY;

  String titel;
  String inhalt;
  String metaDaten;

  boolean overKlick = false;
  boolean postOffen = false;
  boolean artVertikal = true;         // Art dieses Posts: false nach oben, true nach unten
  boolean baumArt;                    // Art des Baumes dieses Posts:  true = kinder, false = eltern
  int postFarbe1;                  // Farbe 1 f\u00fcr den Verlauf
  int postFarbe2;                  // Farbe 2 f\u00fcr den Verlauf
  int textFarbeZu;                  // Farbe f\u00fcr den preview text
  int textFarbeOffen;              // Farbe f\u00fcr den Text, wenn der Post aufgeklappt ist
  int titelFarbeZu;                // Farbe f\u00fcr den mouse-over Titel
  int titelFarbeOffen;                  // Farbe f\u00fcr den Titel in offenen posts

  boolean ichHabDenKlick;
  float relevanz;

  ////////////////////////////////////////////////
  // KONSTRUKTOR
  ////////////////////////////////////////////////
  Post( Vector3D _startPunkt, boolean _baumArt, int _altersNr, int _anzahlPostsInBaum) {
    startPunkt = _startPunkt;
    baumArt = _baumArt;
    altersNr = _altersNr;
    anzahlPostsInBaum = _anzahlPostsInBaum;
    anzahlAntworten = PApplet.parseInt(random(0,20));
    anzahlEltern = PApplet.parseInt(random(2,6));
    partikelErstellen();
    titel = beispielTitel[PApplet.parseInt(random(beispielTitel.length))];
    inhalt = beispielTexte[PApplet.parseInt(random(beispielTexte.length))];
    metaDaten = beispielMetaDaten[PApplet.parseInt(random(beispielMetaDaten.length))];
    hoehe = 10+1.5f*anzahlAntworten;
    originalHoehe = hoehe;
    alteHoehe = hoehe;
    
    ichHabDenKlick = false;
    
    // Relevanz zuf\u00e4llig bestimmen. Die Posts sollen eher einen Hang zur Relevanz als zur nicht-relevanz haben...
    // daher die Schlaufe, die den random n-mal ausf\u00fchrt, und jeweils den gr\u00f6ssten wert ausw\u00e4hlt
    for (int i = 0; i < 3; i++) {
      float neueRelevanz = random(0,30);
      relevanz = max(relevanz, neueRelevanz);
    }
    
    obenLinks = new Vector3D();
    obenRechts = new Vector3D();
    untenLinks = new Vector3D();
    untenRechts = new Vector3D();
    
    // Farben bestimmen, je nach baum-art anders
    if (baumArt) {
      // dieser Post is in einem Kinderbaum
      
      //postFarbe1 = color(30+(170/30)*relevanz, 30+(170/30)*relevanz,30+(170/30)*relevanz);
      //postFarbe2 = color(red(postFarbe1)-75, green(postFarbe1), blue(postFarbe1)+50);
      postFarbe1 = color(20+(160/30)*relevanz, 20+(160/30)*relevanz,20+(160/30)*relevanz);
      postFarbe2 = color(red(postFarbe1)-80, green(postFarbe1), blue(postFarbe1)+25);
      textFarbeZu = color(255,255, 255, 255 );
      textFarbeOffen = color(255,255, 255, 255 );
      titelFarbeZu = color(red(postFarbe2), green(postFarbe2), blue(postFarbe2), 220);
      titelFarbeOffen = color(255,255, 255, 230);

    } else {
      // dieser post ist in einem elternbaum
      //postFarbe1 = color((220/30)*relevanz, (170/30)*relevanz,(170/30)*relevanz);
      //postFarbe2 = color(red(postFarbe1)+175, green(postFarbe1), blue(postFarbe1)-150);
      postFarbe1 = color((220/30)*relevanz, (170/30)*relevanz,(170/30)*relevanz);
      postFarbe2 = color(red(postFarbe1)+150, green(postFarbe1), blue(postFarbe1)-100);
      textFarbeZu = color(255,255, 255, 255 );
      textFarbeOffen = color(255,255, 255, 255 );
      titelFarbeZu = color(red(postFarbe2), green(postFarbe2), blue(postFarbe2), 220);
      titelFarbeOffen = color(255,255, 255, 230);
    }
    // den verlauf erstmalig erstellen
    verlaufErstellen();
    
  }


  ////////////////////////////////////////////////
  // LOOP
  //
  // Wir in jedem Frame wiederholt. wird vom \u00fcber-
  // geordneten Post-Objekt aufgerufen
  ////////////////////////////////////////////////
  public void run() 
  {
     errechneEckenUndMaus();
     if ((obenLinks.x*smoother.z() < width-smoother.x()*smoother.z()) && (obenLinks.y*smoother.z()  < height-smoother.y()*smoother.z()) && (untenLinks.y > 0-smoother.y() ) && (obenRechts.x > 0-smoother.x()) ) {

      // nur die partikel zeichnen, die sich im sichtfeld befinden
     
      breite = obenRechts.x - obenLinks.x;
      zeichneRepraesentant();
    // MOUSE OVER
    //
    if (mousePressed && !keyPressed) {
      // die Maus ist gedr\u00fcckt
      if (overKlick == false ) {
        // die Maus war im letzten Frame NICHT \u00fcber dem Post
        if (over()&& (ichHabDenKlick || klickAktiv)) {
          // ich bin neu \u00fcber dem Post (ROLLOVER)  
          overKlick = true;
          if (postOffen == false) {
            // der Post ist nicht offen, also das ding aufschwabbeln
            meineSpring.setRestLength(40);
            hoehe = originalHoehe + ersteVergroesserung;

          }
        } 
        else {
          // ich bin immernoch nicht \u00fcber dem Post
          // r\u00fcckbau -> falls ich noch mousePressed bin, aber nicht mehr \u00fcber dem Post, muss dieser trotzem schrumpfen  
          postSchrumpft();
          ichHabDenKlick = false;
          if (postOffen) {
            zeichneText();
            zeichneTitel();
          }
        }
      } 
      else {
        // die Maus war im letzten Frame \u00fcber dem Post
        if (globalMouseX < obenLinks.x || globalMouseX > obenRechts.x) {
          // ich bin auf der X-Achse ausserhalb des Posts
          // 
          overKlick = false;
          ichHabDenKlick = false;
          klickAktiv = true;
          postSchrumpft();
          println("jetzt");
        } 
        else {
          // ich bin auf der X-Achse noch INNERHALB des Posts  
          if ((globalMouseY > (linkesPartikel.position().y() + (originalHoehe + ersteVergroesserung)/2))  && (ichHabDenKlick || klickAktiv)) {
          //if (globalMouseY > untenLinks.y) {
            //if (mouseY > linkesPartikel.position().y() + hoehe) {
            //Die Maus wurde nach UNTEN gezogen
            // also die hoehe anpassen
            // ich bin nach unten aufgezogen  
            artVertikal = true;
            postOffen = true;
            hoehe = globalMouseY - obenLinks.y;
            klickAktiv = false;
            ichHabDenKlick = true;
            
            meineSpring.setRestLength(200);
            
            zeichneText();
            zeichneTitel();
            // hier die 2 weiteren Posts-objekte erstellen, falls sie noch nicht existieren
            kinderElternErstellen();
            //translationUpdaten();
          }
          else if ((globalMouseY < (linkesPartikel.position().y() - (originalHoehe + ersteVergroesserung)/2)) && (ichHabDenKlick || klickAktiv)) {
            //Die Maus wurde nach OBEN gezogen
            // also die hoehe anpassen  
            // der post ist nach oben aufgezogen
            artVertikal = false;
            postOffen = true;
            hoehe =  untenLinks.y - globalMouseY;
            
            meineSpring.setRestLength(200);
            zeichneText();
            zeichneTitel();
            // hier die 2 weiteren Posts-objekte erstellen, falls sie noch nicht existieren
            kinderElternErstellen();
            klickAktiv = false;
            ichHabDenKlick = true;
          } 
          else {
            // Die Maus ist geklickt \u00fcber dem Post, aber NICHT nach unten gezogen
            // Also den Post nur ein wenig aufspannen (rollover-m\u00e4ssig)
            meineSpring.setRestLength(40);
            hoehe = originalHoehe + ersteVergroesserung;
            postOffen = false;
            artVertikal = true;
            //ichHabDenKlick = false;
            //println("zu");
            zeichneText();
            zeichneLinie();
            zeichneTitel();
            if (kinderBaum != null) {
              // falls ich schon kinder/eltern habe, diese hier l\u00f6schen
              kinderBaum.kill();
              elternBaum.kill(); 
              kinderBaum = null;
              elternBaum = null; 
              
              // dem PostS-Objekt mitteilen, dass ein Post weniger offen ist
             postsRef.updateOffenePosts(-1);
            }
          }
        }  
      }
    } 
    else {
      // die Maus ist nicht gedr\u00fcckt. 
      if (postOffen) {
        zeichneText();
        zeichneTitel();
      }
      overKlick = false; // n\u00f6tig?! 
      postSchrumpft();
      //ichHabDenKlick = false;
    }

    }

    if (kinderBaum != null) {
      kinderElternVerschieben();
      kinderBaum.run();
      elternBaum.run();

    }
    
    if (hoehe != alteHoehe) {
      // nur wenn sich die hoehe ge\u00e4ndert hat, einen neuen verlauf erstellen (performance!)
     verlaufErstellen(); 
    }
    alteHoehe = hoehe;
    }
  


  public void partikelErstellen() { 
    // Ein neues Partikel erstellen, und es mit Spring und Attraction ausr\u00fcsten
    linkesPartikel = physics.makeParticle();
    rechtesPartikel = physics.makeParticle();
    fill(200,0,9);
    //ellipse(startPunkt.x, startPunkt.y, 10, 10);
    postSpring( linkesPartikel, rechtesPartikel );              // eine Spring (Feder) hinzuf\u00fcgen
    //postAttraction( linkesPartikel, rechtesPartikel );        // eine Attraction hinzuf\u00fcgen

    linkesPartikel.moveTo( startPunkt.x, startPunkt.y+hoehe, 0 );     // das neue Partikel an einen Startplatz verschieben
    rechtesPartikel.moveTo( startPunkt.x , startPunkt.y+hoehe, 0);
  }



  public void postAttraction( Particle p, Particle r ) {
    for ( int i = 0; i < physics.numberOfParticles(); ++i )
    {
      Particle q = physics.getParticle( i );
      if ( p != q && p != r ) {
        meineAttraction = physics.makeAttraction( p, q, -attractionStrength, 0 );
      }
    }
  }


  public void postSpring( Particle a, Particle b ) {
    meineSpring = physics.makeSpring( a, b, springStrength, springDamping, springLength );
  }
  
  
  
  public void zeichneLinie() 
    // zeichnet die kleine Linie zwischen Post und Titel
  {
    strokeWeight(0.5f);
    stroke(postFarbe2);
    line(obenLinks.x + breite/2, obenLinks.y, obenLinks.x + breite/2, obenLinks.y-20);
  }






  public void zeichneTitel() 
    // Zeichnet den Titel des aktiven Posts
  {

    if (postOffen) {
      fill(titelFarbeOffen);
      textFont(fontTitelOffen, 18);
      //textSize(16);
      //float textBreite = textWidth(titel);
      float textHoehe = textAscent() + textDescent();
      float feldBreite = breite - 10;

      text(titel, obenLinks.x +5, obenLinks.y + 5, feldBreite, textHoehe);
      
    } 
    else {
      fill(titelFarbeZu);
      textFont(fontTitelZu, 30);
      float textBreite = textWidth(titel);
      text(titel, obenLinks.x + breite/2 - textBreite/2, obenLinks.y - 20);  
    }
  }



  public void zeichneText()
    // Zeichnet den Text des Posts
  {
    
    if (postOffen) {
      
      fill(textFarbeOffen);
      textFont(fontMeta, 9);
      text(metaDaten, obenLinks.x + 5, obenLinks.y + 25, breite-10, 40);
      if (hoehe - 80 > 0) {
        textFont(fontInhaltOffen, 9);
        text(inhalt, obenLinks.x + 5, obenLinks.y + 70, breite-15, hoehe-80);
      }
    } 
    else {
      textFont(fontInhaltZu, 8);
      fill (textFarbeZu);
      text(inhalt, obenLinks.x + 5, obenLinks.y +5, breite-10, hoehe-10);
    }
  }





  public void zeichneRepraesentant() 
    // Darstellung des Posts selbst (rechtecke)
  {
    noStroke();
    fill(postFarbe1);

    if (artVertikal) {
      // nach UNTEN
      for(int y=0; y<PApplet.parseInt(verlaufsFarben.length); y++) {
        // die gradient-klasse kann nicht sauber mit transparenzen umgehen... daher wird hier die transparenz hinzugef\u00fcgt
        int farbeTrans = color(red(verlaufsFarben[y]), green(verlaufsFarben[y]), blue(verlaufsFarben[y]), 200);
        fill(farbeTrans);
        // auch bei linien gibt es probleme mit den transparenzen... daher wird ein rect mit der hoehe 1 verwendet
        rect( PApplet.parseInt(obenLinks.x), PApplet.parseInt(obenLinks.y + y), PApplet.parseInt(breite) , 1 ); 
      }
    } else {
      // nach OBEN 
      for(int y=verlaufsFarben.length-1; y>0; y--) {
        // die gradient-klasse kann nicht sauber mit transparenzen umgehen... daher wird hier die transparenz hinzugef\u00fcgt
        int farbeTrans = color(red(verlaufsFarben[y]), green(verlaufsFarben[y]), blue(verlaufsFarben[y]), 200);
        fill(farbeTrans);
        // auch bei linien gibt es probleme mit den transparenzen... daher wird ein rect mit der hoehe 1 verwendet
        rect( PApplet.parseInt(obenLinks.x), PApplet.parseInt(obenLinks.y+y), PApplet.parseInt(breite) , 1 ); 
      }
    }
  }





  public void postSchrumpft()
    // Normalisiert die Gr\u00f6sse des Posts, falls der Post nicht gerade offen ist
    
  {
    if (postOffen == false) {
      if (meineSpring.restLength() > springLength) {
        float rest = (meineSpring.restLength() - springLength) / 10;
        meineSpring.setRestLength(meineSpring.restLength()-rest);
      }

      if (hoehe > originalHoehe) {   
        hoehe = hoehe - (hoehe - originalHoehe) /10;  

      }
    }
  }




  public void errechneEckenUndMaus() {
    // Errechnet aus der hohe und der position der partikel die koordinaten der 4 Ecken des posts
    
    if (postOffen) {
     // der Post ist OFFEN, also \u00fcberpr\u00fcfen, in welche richtung
    
      if (artVertikal) {
         // ich bin nach UNTEN offen
         obenLinks.setXYZ(linkesPartikel.position().x(), linkesPartikel.position().y()-(originalHoehe+ersteVergroesserung)/2, 0);
         obenRechts.setXYZ(rechtesPartikel.position().x(), rechtesPartikel.position().y()-(originalHoehe+ersteVergroesserung)/2, 0);
         untenLinks.setXYZ(linkesPartikel.position().x(), linkesPartikel.position().y()+ hoehe - (originalHoehe+ersteVergroesserung)/2, 0);
         untenRechts.setXYZ(rechtesPartikel.position().x(), rechtesPartikel.position().y()+ hoehe - (originalHoehe+ersteVergroesserung)/2, 0);
      } else {
         // ich bin nach OBEN offen
         obenLinks.setXYZ(linkesPartikel.position().x(), linkesPartikel.position().y()-hoehe + (originalHoehe+ersteVergroesserung)/2, 0);
         obenRechts.setXYZ(rechtesPartikel.position().x(), rechtesPartikel.position().y()-hoehe + (originalHoehe+ersteVergroesserung)/2, 0);
         untenLinks.setXYZ(linkesPartikel.position().x(), linkesPartikel.position().y()+(originalHoehe+ersteVergroesserung)/2, 0);
         untenRechts.setXYZ(rechtesPartikel.position().x(), rechtesPartikel.position().y()+(originalHoehe+ersteVergroesserung)/2, 0);
      } 
    } else {
      // der post ist ZU, also einfach einmitten
       obenLinks.setXYZ(linkesPartikel.position().x(), linkesPartikel.position().y()-hoehe/2, 0);
       obenRechts.setXYZ(rechtesPartikel.position().x(), rechtesPartikel.position().y()-hoehe/2, 0);
       untenLinks.setXYZ(linkesPartikel.position().x(), linkesPartikel.position().y()+hoehe/2, 0);
       untenRechts.setXYZ(rechtesPartikel.position().x(), rechtesPartikel.position().y()+hoehe/2, 0);
    }
    
    // Debugging:
    /*
    fill(255, 150);
    noStroke();
    ellipse(obenLinks.x, obenLinks.y, 5, 5);
    ellipse(obenRechts.x, obenRechts.y, 5, 5);
    ellipse(untenLinks.x, untenLinks.y, 5, 5);
    ellipse(untenRechts.x, untenRechts.y, 5, 5);
    
    
        fill(255, 150);
    noStroke();
    ellipse(obenLinks.x-(smoother.z()*smoother.x()), obenLinks.y-(smoother.z()*smoother.y()), 5, 5);
    ellipse(obenRechts.x-(smoother.z()*smoother.x()), obenRechts.y-(smoother.z()*smoother.y()), 5, 5);
    ellipse(untenLinks.x-(smoother.z()*smoother.x()), untenLinks.y-(smoother.z()*smoother.y()), 5, 5);
    ellipse(untenRechts.x-(smoother.z()*smoother.x()), untenRechts.y-(smoother.z()*smoother.y()), 5, 5);
    
    fill(255,0,0);
    ellipse(mouseX/smoother.z() - smoother.x(), mouseY/smoother.z() - smoother.y(), 5, 5);
    */
    globalMouseX = mouseX/smoother.z() - smoother.x();
    globalMouseY = mouseY/smoother.z() - smoother.y();
  }
  
  
  

  public boolean over()
    // Gibt true zur\u00fcck, wenn sich der Mauspointer auf dem Post befindet. Sonst false.
  {
      if (globalMouseX  >= obenLinks.x && globalMouseX <= obenRechts.x &&
        globalMouseY >=  obenLinks.y && globalMouseY <=  untenLinks.y) {
        println("drin");  
        return true;
      } 
      else {
        return false;  
      }
  }
  
  
  
  
  public void verlaufErstellen() {
    verlauf = null;
    verlauf = new Gradient();

    verlauf.addColor(0,postFarbe1);
    verlauf.addColor(PApplet.parseInt(hoehe),postFarbe2);
    verlaufsFarben = verlauf.calcGradient(0,PApplet.parseInt(hoehe)); 
  }





  public void kinderElternErstellen()
    // erstellt die kinder und eltern b\u00e4ume
  {
    if (kinderBaum == null && anzahlAntworten > 0) {
      // dem PostS-objekt mitteilen, dass ein neues Ding offen ist.
     postsRef.updateOffenePosts(1);
      
      Vector3D start = new Vector3D();
      Vector3D ende = new Vector3D();
      if (artVertikal) {
        // bin nach UNTEN aufgezogen
        start.setXYZ(untenRechts.x, untenRechts.y, 0);
        ende.setXYZ(untenRechts.x + anzahlAntworten*25, untenRechts.y, 0);
      } 
      else {
        // bin nach oben aufgezogen
        start.setXYZ(obenRechts.x, obenRechts.y, 0);
        ende.setXYZ(obenRechts.x + anzahlAntworten*25, obenRechts.y, 0);
      }
      kinderBaum = new Posts(start, ende, anzahlAntworten, true);

      if (artVertikal) {
        // bin nach UNTEN aufgezogen
        start.setXYZ(untenLinks.x - anzahlEltern*25, untenLinks.y, 0);
        ende.setXYZ(untenLinks.x, untenLinks.y, 0);
      } 
      else {
        // bin nach oben aufgezogen
        start.setXYZ(obenLinks.x - anzahlEltern*25, obenLinks.y, 0);
        ende.setXYZ(obenLinks.x , obenLinks.y, 0);
      }

      elternBaum = new Posts(start, ende, anzahlEltern, false);
    } 
  }
  
  
  
  

  public void kinderElternVerschieben()
    // verschiebt die Ankerpunkte der eltern und kinder-b\u00e4ume
  {
    float verrechnungY;
    if (artVertikal) {
      // nach UNTEN offen
      kinderBaum.sollSystemStart.setXYZ(untenRechts.x, untenLinks.y, 0);
      elternBaum.sollSystemEnd.setXYZ(untenLinks.x, untenRechts.y, 0);
    } else {
      // nach OBEN offen
      kinderBaum.sollSystemStart.setXYZ(obenRechts.x, obenRechts.y, 0);
      elternBaum.sollSystemEnd.setXYZ(obenLinks.x, obenLinks.y, 0);
    }
  }






  public void postsRef(Posts _postsRef) {
    // wird vom Posts-objekt aufgerufen, dass diesen Post erstellt hat 
    // macht diesem Post das PostS-objetkt bekannt
     postsRef = _postsRef; 
    // println(postsRef.springLength);
  }





  public void mouseReleased() 
  {
    overKlick = false; 
  }





  public void kill() 
    // l\u00f6scht die Partikel dieses Posts
  {
    linkesPartikel.kill();
    rechtesPartikel.kill();
    if (kinderBaum != null) {
      kinderBaum.kill();
      elternBaum.kill(); 
      kinderBaum = null;
      elternBaum = null;
    }
  }

}



// Blogosphere Browser 0.1
// Patrick Meister, Juni 2006


class Posts {
  ArrayList postListe;                     // Liste mit Post Objekten
  ArrayList springListe;                   // Liste mit den Springs der Abst\u00e4nde
  ArrayList attractionListe;               // Liste mit den Attractions der Abst\u00e4nde
  Particle ersterAnker;                    // Erster Fixierpunkt, rahmt die Post-Partikel ein
  Particle letzterAnker;                   // Zweiter Fixierpunkt
  Vector3D systemStart;                    // aktuelle Start-Position des Systems
  Vector3D systemEnd;                      // aktuelle End-Position des Systems
  Vector3D sollSystemStart;                // Soll-Start-Position des Systems
  Vector3D sollSystemEnd;                  // Soll-End-Position des systems

  float springLength = 0.1f;    // 0.1
  float springStrength = 1.7f;  // 1.7
  float attractionStrength = 50; // 50
  float springDamping = 0.1f;    // 1.7

  int anzahlPosts;                         // Anzahl Posts in diesem Partikel-System      
  int partikelStartBestand;                // Anzahl der Partikel, als dieses Posts-Objekt erstellt wurde
  boolean baumArt;                         // Art dieses Baums: true= kinder, false = eltern
  int anzahlOffenePosts;                   // Speichert die Anzahl offene Posts in diesem Strang.

  // CONSTRUCTOR
  // Richtet das Posts-Objekt ein
  Posts(Vector3D _systemStart, Vector3D _systemEnd, int _anzahlPosts, boolean _baumArt) {
    sollSystemStart = _systemStart;
    sollSystemEnd = _systemEnd;
    systemStart = _systemStart;
    systemEnd = _systemEnd;
    anzahlPosts = _anzahlPosts;
    baumArt = _baumArt;
    partikelStartBestand = physics.numberOfParticles();
     anzahlOffenePosts = 0;

    postListe = new ArrayList();
    springListe = new ArrayList();
    attractionListe = new ArrayList();
    ankerErstellen();
    postsErstellen();
    ankerVerbinden();
    
  }

  // LOOP
  public void run() {
    // Jedes Post-objekt ankicken
    //println(anzahlOffenePosts);
    
    
    for (int i = 0; i < postListe.size(); i++) {
      Post p = (Post) postListe.get(i);
      p.run();    
    }
     
   Vector3D start = new Vector3D();
   Vector3D end = new Vector3D();
  
   if (baumArt) {
     // ich bin ein Kinder-baum, 
     // der endpunkt muss also verschoben werden
     float sollX = sollSystemStart.x+anzahlPosts*25+(anzahlOffenePosts)*200;
     float futureX = letzterAnker.position().x() + (sollX-letzterAnker.position().x())/30;
     //println(futureX);
     start.setXYZ(sollSystemStart.x, sollSystemStart.y, 0);
     end.setXYZ(futureX, sollSystemStart.y, 0);
     fill(0,0,200);
     //ellipse(ersterAnker.position().x(), ersterAnker.position().y(), 20, 20);  
     //ellipse(letzterAnker.position().x(), letzterAnker.position().y(), 20, 20);
   } else {
     // ich bin ein elternbaum
     // der startpunkt muss also verschoben werden
     float sollX = sollSystemEnd.x-anzahlPosts*25-(anzahlOffenePosts)*200;
     float futureX = ersterAnker.position().x() - (ersterAnker.position().x()-sollX)/30;
     //println(futureX);
     start.setXYZ(futureX, sollSystemEnd.y, 0);
     end.setXYZ(sollSystemEnd.x, sollSystemEnd.y, 0);
     fill(0,0,200);
     //ellipse(ersterAnker.position().x(), ersterAnker.position().y(), 20, 20);  
   }
   
   ankerVerschieben(start, end);
     
     
  }


  public void ankerErstellen() {
    // Die beiden \u00e4usseren, nicht sichtbaren Partikel erstellen.
    // Sie sind fixiert, damit sie die Post-Partikel halten.
    ersterAnker = physics.makeParticle();
    letzterAnker = physics.makeParticle();
    ersterAnker.moveTo(systemStart.x, systemStart.y, systemStart.z);
    letzterAnker.moveTo(systemEnd.x, systemEnd.y, systemEnd.z);
    ersterAnker.makeFixed();
    letzterAnker.makeFixed();  
  }


  public void postsErstellen() {
    // Erstellt Posts
    // zwischen den Ankern
    
    for (int i = 0; i < anzahlPosts; i++) {
      Vector3D startPunkt = new Vector3D();
      float neuX;
      if (baumArt) {
        // bin ein kinderbaum
        neuX =  sollSystemStart.x +((sollSystemEnd.x-sollSystemStart.x)/anzahlPosts*(i));
      } else {
        neuX =  sollSystemEnd.x - anzahlPosts*25 - ((sollSystemEnd.x-sollSystemStart.x)/anzahlPosts*(i));
      }
      startPunkt.setXYZ(neuX, mouseY/smoother.z() - smoother.y(), 0);
      fill(0,200,0);
      //ellipse(startPunkt.x, startPunkt.y, 10, 10);
      Post neuerPost = new Post(startPunkt, baumArt, i, anzahlPosts);
      postListe.add(neuerPost);
      if (i > 0) {
        Particle p1 = physics.getParticle(physics.numberOfParticles()-2);
        Particle p2 = physics.getParticle(physics.numberOfParticles()-3);
        abstandSpring(p1, p2);
        //abstandAttraction(p1, p2);
      }
      neuerPost.postsRef(this);

    }
  }


  public void ankerVerbinden() {
    Particle p1 = physics.getParticle(partikelStartBestand);
    Particle p2 = physics.getParticle(partikelStartBestand+2);
    Particle p3 = physics.getParticle(physics.numberOfParticles()-1);
    Particle p4 = physics.getParticle(partikelStartBestand+1);
    abstandSpring(p1, p2);
    abstandSpring(p3, p4);
  }

  public void abstandAttraction( Particle p, Particle r )
  {
    for ( int i = 0; i < physics.numberOfParticles(); ++i )
    {
      Particle q = physics.getParticle( i );
      if ( p != q && p != r ) {
        Attraction a = physics.makeAttraction( p, q, -attractionStrength, 10 );
        attractionListe.add(a);
      }
    }
  }

  public void abstandSpring( Particle a, Particle b )
  {
    Spring s = physics.makeSpring( a, b, springStrength, springDamping, springLength );
    springListe.add(s);
  }

  public void ankerVerschieben(Vector3D _start, Vector3D _end) {

    systemStart = _start.copy(); //.setXYZ(systemStart.x, mouseY, 0);
    systemEnd = _end.copy(); //.setXYZ(systemEnd.x, mouseY, 0);
    ersterAnker.moveTo(systemStart.x, systemStart.y, systemStart.z);
    letzterAnker.moveTo(systemEnd.x, systemEnd.y, systemEnd.z);  
  }

  public void updateOffenePosts(int _veraenderung) {
   //wird von den eigenen posts aufgerufen, wenn sie sich \u00f6ffnen oder schliessen 
   anzahlOffenePosts += _veraenderung;
   println(anzahlOffenePosts);

   
   
  }
  
  public void kill()
    // killt alle Posts
  {
    for (int i = 0; i < postListe.size(); i++) {
      Post p = (Post) postListe.get(i);
      p.kill();    
    }

  }

}
static public void main(String args[]) {   PApplet.main(new String[] { "dummy42_rotblau_web" });}}