import traer.physics.*;
import processing.opengl.*;
import traer.animation.*;

String[] beispielTitel =  {
    "Pftzen, Pftzen", "Ein Tag ohne Regen...", "Was habt ihr alle mit dem Wetter?", "Ich mag Herbstwetter", "Schneits bald wieder?", "Im September wars schner", "Morgen wird es regnen","Regnet es morgen?","Absoluter Stuss!", "Die Regenmacher", "Der Sommer lsst auf sich warten!", "Regenschirm einpacken!", "Meteorologengequassel..."};

String[] beispielTexte = {
   "Das ist ein furchtbar langer, schwer zu lesener und beraus schlecht geschriebener Text. Dieser Text sollte von ihnen nicht gelesen werden.\n\nLesen Sie immer noch? Ok, dann gibts ne kleine Geschichte. Und wenn sie heute noch lesen, lesen sie immer noch. \nDas ist ein furchtbar langer, schwer zu lesener und beraus schlecht geschriebener Text. \n\nDieser Text sollte von ihnen nicht gelesen werden. Lesen Sie immer noch? Ok, dann gibts ne kleine Geschichte. Und wenn sie heute noch lesen, lesen sie immer noch.",
  "Das ist ein furchtbar langer, schwer zu lesener und beraus schlecht geschriebener Text. Dieser Text sollte von ihnen nicht gelesen werden.",
  "Das ist ein furchtbar langer, schwer zu lesener und beraus schlecht geschriebener Text. Dieser Text sollte von ihnen nicht gelesen werden.\nLesen Sie immer noch? Ok, dann gibts ne kleine Geschichte. Und wenn sie heute noch lesen, lesen sie immer noch. \nDas ist ein furchtbar langer, schwer zu lesener und beraus schlecht geschriebener Text. \n\nDieser Text sollte von ihnen nicht gelesen werden. Lesen Sie immer noch? Ok, dann gibts ne kleine Geschichte. Und wenn sie heute noch lesen, lesen sie immer noch. Das ist ein furchtbar langer, schwer zu lesener und beraus schlecht geschriebener Text. Dieser Text sollte von ihnen nicht gelesen werden.\n\nLesen Sie immer noch? Ok, dann gibts ne kleine Geschichte. Und wenn sie heute noch lesen, lesen sie immer noch. \nDas ist ein furchtbar langer, schwer zu lesener und beraus schlecht geschriebener Text. \n\nDieser Text sollte von ihnen nicht gelesen werden. Lesen Sie immer noch? Ok, dann gibts ne kleine Geschichte. Und wenn sie heute noch lesen, lesen sie immer noch.",
  "Das ist ein furchtbar langer, schwer zu lesener und beraus schlecht geschriebener Text. Dieser Text sollte von ihnen nicht gelesen werden.\nLesen Sie immer noch? Ok, dann gibts ne kleine Geschichte. Und wenn sie heute noch lesen, lesen sie immer noch. \n\nDas ist ein furchtbar langer, schwer zu lesener und beraus schlecht geschriebener Text."
  };
  
String[] beispielMetaDaten = {
  "Geschrieben am 24.06.2006\nvon Hans Brinker\nHansBrinker Hotel Blog",
  "Geschrieben am 29.06.2006\nvon Jrg Kachelmann\nDer Wetterblog",
  "Geschrieben am 05.07.2006\nvon Daniel Fischer\nDani's Olalaola-Blog",
  "Geschrieben am 04.07.2006\nvon Hazzle Schnibblr\nFreaks Online",
  "Geschrieben am 22.06.2006\nvon Heiri Mller\nTagesschau Revisited",
  "Geschrieben am 01.02.2006\nvon Bauer Horst\nDer Rebli-Talk",
  "Geschrieben am 12.07.2006\nvon Kai Wied\nKais Tuschlerei",
};

PFont fontInhaltOffen;
PFont fontInhaltZu;
PFont fontMeta;
PFont fontTitelOffen;
PFont fontTitelZu;

Smoother3D smoother;
ParticleSystem physics;                  // Partikel-System Objekt 
public Posts posts;

boolean klickAktiv;
float globaleHoehe = 30;
Vector3D globaleTranslation;
Vector3D alteMausPos;


// PROCESSING /////////////////////////////////////

void setup()
{
  size( 900, 600, OPENGL );
  //smooth();
  frameRate( 24 );
  strokeWeight( 2 );
  rectMode(CORNER);  
//textMode(SCREEN);
  physics = new ParticleSystem( 0, .16 );
  smoother = new Smoother3D( 0.9 );
  smoother.setTarget(0,0,1); // da der z-wert als scale missbraucht wird, hier auf 1 setzen, damit am anfang nicht gerade skalliert wird
  Vector3D start = new Vector3D();


  globaleTranslation = new Vector3D();
  globaleTranslation.setXYZ(0,0,0);
  alteMausPos = new Vector3D();
  
  // Text fr inhalt offen: Verdana Roman 10pt
  // Text fr inhalt zu: Verdana Roman 8pt
  // Text fr Meta: Verdana Italic 9pt
  // Text fr Titel zu: Bauer Bodoni Roman 18pt
  // Text fr titel offen: Bauer Bodoni Roman 25pt
  //fontInhaltOffen = loadFont("Verdana-20.vlw");
  fontInhaltOffen = loadFont("Verdana-14.vlw");
  fontInhaltZu = loadFont("Verdana-16.vlw");
  fontMeta = loadFont("Verdana-Italic-18.vlw");
  //fontTitelOffen = loadFont("BauerBodoni-Roman-36.vlw");
  fontTitelOffen = loadFont("BauerBodoni-Roman-20.vlw");
  //fontTitelZu = loadFont("BauerBodoni-Roman-50.vlw");
  fontTitelZu = loadFont("BauerBodoni-Roman-30.vlw");

  Vector3D ende = new Vector3D();
  start.setXYZ(200, 200,0);
  ende.setXYZ(start.x + 10 *25, 200, 0);
  posts = new Posts(start, ende, 10, true);
  postsErstellen();
}

void draw()
{
  //println(klickAktiv);
   background( 0 );
   
   physics.tick( 1.4 ); 
   physics.tick( 1.4 );

   scale(smoother.z());
   pushMatrix();
   translate(smoother.x(), smoother.y());
   smoother.tick();
   


   fill(255,255,255);
   textFont(fontTitelOffen, 24);
   float textBreite = textWidth("Wetter:");
   float textHoehe = textAscent() + textDescent();
   float feldBreite = textBreite;
   text("Wetter:", 200-feldBreite-10,200-textHoehe/2, feldBreite, textHoehe);

  strokeWeight(3);
  stroke(255,0,0);

  posts.run();
  
  strokeWeight(0.5);
  stroke(255,255,255, 255 );
  /*
  beginShape( LINES );
   for ( int i = 0; i < physics.numberOfSprings(); ++i )
   {
   Spring e = physics.getSpring( i );
   Particle a = e.getOneEnd();
   Particle b = e.getTheOtherEnd();
   vertex( a.position().x(), a.position().y() );
   vertex( b.position().x(), b.position().y() );
   
   //vertex( mouseX,mouseY);
   //vertex( b.position().x(), b.position().y() );
   //vertex( width,height);
   }
   endShape();
   */
   popMatrix();
}

void mousePressed() {
  //if (mouseButton == LEFT) {
  if (keyPressed && key == ' ') {
     alteMausPos.setXY(mouseX, mouseY);
     println("mouse pressed"); 
  }  else if (keyPressed && key == 'z') {
     alteMausPos.setXY(mouseX, mouseY);
     println("mouse pressed zoom"); 
  } else {
   klickAktiv = true; 
  }
}




void mouseDragged() {
    if ( keyPressed && key == ' '){
      
    Vector3D unterschied = new Vector3D();
    unterschied.setXY(mouseX, mouseY);
    unterschied.sub(alteMausPos);
    globaleTranslation.add(unterschied);
    alteMausPos.setXY(mouseX, mouseY);
    
    smoother.setTarget(globaleTranslation.x/smoother.z(), globaleTranslation.y/smoother.z(),smoother.z());
 
    } else if ( keyPressed && key == 'z'){
      float unterschied1 =  (alteMausPos.x-mouseX)/width;
      Vector3D unterschied = new Vector3D();
      Vector3D blabla = new Vector3D();
      blabla = alteMausPos.copy();
      unterschied = alteMausPos.copy();
      unterschied.mult(unterschied1);
      unterschied.sub(alteMausPos);
      
      //line(blabla.x, blabla.y, alteMausPos.x, alteMausPos.y);
      point(blabla.x, blabla.y);
      
      
      smoother.setTarget(smoother.x(), smoother.y(), smoother.z()+unterschied1); 
      //println(alteMausPos.x);
    }
}


void keyPressed()
{
  if ( key == 'c' )
  {
    postsErstellen();
  }
  
  if ( key == ' ' )
  {
   if (mousePressed) {
           alteMausPos.setXY(mouseX, mouseY);
     //println("spezial"); 
   } 
  }
  
  if (key == 'z') {
    
     if (mousePressed) {
           //alteMausPos.setXY(mouseX, mouseY);
     //println("spezial"); 
   } 
  }


}

void postsErstellen() {
    posts.kill();
    posts = null;
    Vector3D start = new Vector3D();
    Vector3D ende = new Vector3D();
    int randomAnzahl = int(random(1,20));
    start.setXYZ(200, 200,0);
    ende.setXYZ(start.x + randomAnzahl * 25, 200, 0);
    posts = new Posts(start, ende, randomAnzahl, true);
    smoother.setTarget(0,0,1);
}

void updateCentroid()
{
  
  // die Test-Variablen auf die negative, resp. positive grsste mgliche zahl setzen,
  // um nachher auf jede zahl vorbereitet zu sein
  float 
    xMax = Float.NEGATIVE_INFINITY, 
    xMin = Float.POSITIVE_INFINITY, 
    yMin = Float.POSITIVE_INFINITY, 
    yMax = Float.NEGATIVE_INFINITY;

// den hchsten resp. tiefsten x-/y-werte herausfinden
  for ( int i = 0; i < physics.numberOfParticles(); ++i )
  {
    //max() gibt die grssere der beiden zahlen zurck, min() die kleinere
    Particle p = physics.getParticle( i );
    xMax = max( xMax, p.position().x() );
    xMin = min( xMin, p.position().x() );
    yMin = min( yMin, p.position().y() );
    yMax = max( yMax, p.position().y() );
  }
  float deltaX = xMax-xMin;
  float deltaY = yMax-yMin;
  if ( deltaY > deltaX )
    smoother.setTarget( xMin + 0.5*deltaX, yMin +0.5*deltaY, height/(deltaY+50) );
  else
    smoother.setTarget( xMin + 0.5*deltaX, yMin +0.5*deltaY, width/(deltaX+50) );
}
